<?php
/*
Plugin Name: WP-Options-Manager
Plugin URI: http://wordpress.org/extend/plugins/wp-options-manager/
Version: 0.02
Author: Marc Schieferdecker
Author URI: http://www.das-motorrad-blog.de
Description: With this plugin you can browse the entrys of your WordPress options database table. You can debug and delete entrys. An automatic search for deprecated options is also available. Very useful to delete deprecated or old options from uninstalled plugins.
License: GPL
*/

define( 'WPOM_PLUGIN_PATH', dirname(__FILE__) . '/../' );

// The main plugin class
class wp_options_manager
{
	var $db;
	var $tp;
	var $wp_default_options;
	var $wp_popular_plugins;

	// Construct
	function __construct()
	{
		// Get db object
		global $wpdb;
		$this -> db =& $wpdb;

		// Get table prefix
		global $table_prefix;
		$this -> tp = $table_prefix;

		// Set wp default options
		$this -> wp_default_options = array( 'siteurl', 'blogname', 'blogdescription', 'users_can_register', 'admin_email', 'start_of_week', 'use_balanceTags', 'use_smilies', 'require_name_email', 'comments_notify', 'posts_per_rss', 'rss_excerpt_length', 'rss_use_excerpt', 'mailserver_url', 'mailserver_login', 'mailserver_pass', 'mailserver_port', 'default_category', 'default_comment_status', 'default_ping_status', 'default_pingback_flag', 'default_post_edit_rows', 'posts_per_page', 'what_to_show', 'date_format', 'time_format', 'links_updated_date_format', 'links_recently_updated_prepend', 'links_recently_updated_append', 'links_recently_updated_time', 'comment_moderation', 'moderation_notify', 'permalink_structure', 'gzipcompression', 'hack_file', 'blog_charset', 'moderation_keys', 'active_plugins', 'home', 'category_base', 'ping_sites', 'advanced_edit', 'comment_max_links', 'gmt_offset', 'default_email_category', 'recently_edited', 'use_linksupdate', 'template', 'stylesheet', 'comment_whitelist', 'blacklist_keys', 'comment_registration', 'open_proxy_check', 'rss_language', 'html_type', 'use_trackback', 'default_role', 'db_version', 'wp_user_roles', 'uploads_use_yearmonth_folders', 'upload_path', 'secret', 'blog_public', 'default_link_category', 'show_on_front', 'default_link_category', 'cron', 'doing_cron', 'sidebars_widgets', 'widget_pages', 'widget_calendar', 'widget_archives', 'widget_meta', 'widget_categories', 'widget_recent_entries', 'widget_text', 'widget_rss', 'widget_recent_comments', 'widget_wholinked', 'widget_polls', 'tag_base', 'page_on_front', 'page_for_posts', 'page_uris', 'page_attachment_uris', 'show_avatars', 'avatar_rating', 'upload_url_path', 'thumbnail_size_w', 'thumbnail_size_h', 'thumbnail_crop', 'medium_size_w', 'medium_size_h', 'dashboard_widget_options', 'current_theme', 'auth_salt', 'avatar_default', 'enable_app', 'enable_xmlrpc', 'logged_in_salt', 'recently_activated', 'random_seed', 'large_size_w', 'large_size_h', 'image_default_link_type', 'image_default_size', 'image_default_align', 'close_comments_for_old_posts', 'close_comments_days_old', 'thread_comments', 'thread_comments_depth', 'page_comments', 'comments_per_page', 'default_comments_page', 'comment_order', 'use_ssl', 'sticky_posts', 'dismissed_update_core', 'update_themes', 'nonce_salt', 'update_core', 'uninstall_plugins', 'wporg_popular_tags', 'stats_options', 'stats_cache', 'rewrite_rules', 'update_plugins', 'category_children' );

		// Set wp popular plugins
		$this -> wp_popular_plugins = array(	'aiosp' => 'All in One SEO Pack',
							'a2pPlugin_' => 'article2pdf',
							'akismet' => 'Akismet',
							'wordtube' => 'wordTube',
							'tadv' => 'TinyMCE Advanced',
							'sm_' => 'Google XML Sitemap Generator',
							'simpletags' => 'Simple Tags',
							'poll_' => 'WP-Polls',
							'random-posts' => 'Random posts',
							'ngg_' => 'NextGEN Gallery',
							'widget_nggslideshow' => 'NextGEN Gallery',
							'linklift_' => 'LinkLift',
							'lcb_' => 'List Draft Posts',
							'exec-php' => 'Exec-PHP',
							'fs_' => 'FeedStats',
							'dbmanager_' => 'WP-DBManager',
							'events_calendar' => 'Events Calendar',
							'EventsCalendar' => 'EventsCalendar',
							'wordpress_api_key' => 'WordPress.org plugins',
							'widget_skypewidget' => 'Skype widget',
							'widget_multi_pages' => 'Multi Pages widget',
							'kbrss' => 'KB Advanced RSS Widget',
							'views_options' => 'WP-PostViews',
							'umapper' => 'UMapper',
							'similar-posts' => 'Similar Posts',
							'pc_ignored_plugins' => 'Plugin Central',
							'rss_' => 'internal rss cache (safe to delete if bloated)'
						);
	}
	// PHP4 compatibe construct (please update to PHP 5 soon! ;) )
	function wp_options_manager() { $this -> __construct(); }

	// Admin interface
	function wpom_AdminPage()
	{
		// Language textdomain
		if( function_exists( 'load_plugin_textdomain' ) ) {
			load_plugin_textdomain( 'wpom', 'wp-content/plugins/wp-options-manager' );
		}
		// Set panel to open
		if( $_POST[ 'wpom_admin_action' ] == 'autosearch' )
			$open = 2;
		else
			$open = 1;

		// Container
		print "<div class=\"wrap\">\n";
		print "<h2>" . __( "WP Options Manager", "wpom" ) . "</h2>\n";
		print "<br class=\"clear\"/>";

		// AJAX: Delete option
		if( $_REQUEST[ 'wpom_admin_action' ] == 'delete' )
		{
			$id = intval( $_REQUEST[ 'id' ] );
			$this -> db -> query( "DELETE FROM {$this->tp}options WHERE option_id='$id' LIMIT 1;" );
			// Quit process, we are done
			exit();
		}

		// AJAX: Debug option value
		if( $_REQUEST[ 'wpom_admin_action' ] == 'debug' )
		{
			print "<!-- WPOM AJAX CONTENT -->";	// Use markers, to keep all functions in this file
			$id = intval( $_REQUEST[ 'id' ] );
			$row = $this -> db -> get_row( "SELECT option_value FROM {$this->tp}options WHERE option_id='$id' LIMIT 1;" );
			if( is_object( $row ) )
			{
				$debug = print_r( unserialize( $row -> option_value ), true );
				// If is debugable print debug string
				if( !empty( $debug ) )
				{
					print "<pre>";
					print $debug;
					print "</pre>";
				}
				else
				if( is_numeric( $row -> option_value ) && strlen( $row -> option_value ) >= 8 )
				{
					print strftime( '%x %H:%I', $row -> option_value );
				}
				// Not debugable? Then print original string
				else	print __( "Not debugable:", "wpom" ) . " <i>" . $row -> option_value . "</i>";
			}
			else	print __( "Error. Row not found.", "wpom" );
			print "<!-- WPOM AJAX CONTENT -->";	// Use markers, to keep all functions in this file
			// Quit process, we are done
			exit();
		}

		// Output search options form
		print "<div id=\"poststuff\">\n";
		print "<div class=\"postbox\">\n";
		print "<form name=\"wpom_searchform\" method=\"POST\" action=\"" . $_SERVER[ "REQUEST_URI" ] . "\" enctype=\"multipart/form-data\">\n";
		print "<input type=\"hidden\" name=\"wpom_admin_action\" value=\"search\"/>\n";
		print "<h3>" . __( "Search options in the database table", "wpom" ) . "</h3>\n";
		print "<div class=\"inside\">\n";
		print "<table class=\"widefat post fixed\">";
		print "<tr>";
		print "<td>";
		print "<h4>" . __( "Please enter a search term", "wpom" ) . "</h4>";
		print "<p><input type=\"text\" name=\"wpom_searchterm\" size=\"20\" maxlength=\"20\" value=\"" . htmlentities( $_POST[ 'wpom_searchterm' ] ) . "\"/></p>\n";
		print "</td>";
		print "<td>";
		print "<h4>" . __( "Search in option values also?", "wpom" ) . "</h4>";
		print "<p><select name=\"wpom_search_values\">\n";
			print "<option value=\"false\"" . ($_POST[ 'wpom_search_values' ] == 'false' ? "selected=\"selected\"" : "") . ">" . __( "No, please not", "wpom" ) . "</option>\n";
			print "<option value=\"true\"" . ($_POST[ 'wpom_search_values' ] == 'true' ? "selected=\"selected\"" : "") . ">" . __( "Yes, do that!", "wpom" ) . "</option>\n";
		print "</select></p>\n";
		print "</td>";
		print "<td>";
		print "<h4>" . __( "Hide WP default options?", "wpom" ) . "</h4>";
		print "<p><select name=\"wpom_hide_default_options\">\n";
			print "<option value=\"true\"" . ($_POST[ 'wpom_hide_default_options' ] == 'true' ? "selected=\"selected\"" : "") . ">" . __( "Yes, do that!", "wpom" ) . "</option>\n";
			print "<option value=\"false\"" . ($_POST[ 'wpom_hide_default_options' ] == 'false' ? "selected=\"selected\"" : "") . ">" . __( "No, please not", "wpom" ) . "</option>\n";
		print "</select></p>\n";
		print "</td>";
		print "<td>";
		print "<p class=\"submit\"><br/><input type=\"submit\" name=\"wpom_submitsearch\" value=\"" . __( "Search options", "wpom" ) . "\"/></p>\n";
		print "</td>";
		print "</tr>";
		print "<tr><td colspan=\"4\">" . __( "Hint: You don't have to enter a search term. Use a blank search term and search with \"hide default entrys\" set to \"yes\" to see all options not from WordPress itself.", "wpom" ) . "</td></tr>";
		print "</table>";
		print "</form>\n";
		// Run search
		if( $_POST[ 'wpom_admin_action' ] == 'search' )
		{
			$term = strtolower( mysql_real_escape_string( $_POST[ 'wpom_searchterm' ] ) );
			if( $_POST[ 'wpom_search_values' ] == 'false' )
				$rowsfound = $this -> db -> query( "SELECT * FROM {$this->tp}options WHERE option_name LIKE '%$term%' ORDER BY blog_id ASC, option_name ASC;" );
			else
				$rowsfound = $this -> db -> query( "SELECT * FROM {$this->tp}options WHERE option_name LIKE '%$term%' OR option_value LIKE '%$term%' ORDER BY blog_id ASC, option_name ASC;" );
			if( $rowsfound )
			{
				// Output hits
				print "<p><strong>" . __( "Number of entrys found:", "wpom" ) . " $rowsfound</strong></p>\n";
				if( $_POST[ 'wpom_hide_default_options' ] == 'true' )
					print "<p>" . __( "Maybe not all of the entrys will be displayed, because you activated the \"Hide default options\" feature.", "wpom" ) . "</p>";
				// Output
				print "<p><table class=\"widefat post fixed\">\n";
				print "<thead>\n";
				print "<tr><th class=\"manage-column\" width=\"80\">" . __( "Option ID", "wpom" ) . "</th><th width=\"200\">" . __( "Option name", "wpom" ) . "</th><th>" . __( "Option value", "wpom" ) . "</th><th width=\"100\">" . __( "Autoloaded?", "wpom" ) . "</th><th width=\"100\">" . __( "Choose action", "wpom" ) . "</th></tr>\n";
				print "</thead>\n";
				print "<tbody>\n";
				foreach( $this -> db -> last_result AS $row )
				{
					if( !in_array( $row -> option_name, $this -> wp_default_options ) || $_POST[ 'wpom_hide_default_options' ] == 'false' )
					{
						$row -> option_value = wordwrap( $row -> option_value, 25, " ", true );
						$row -> option_value = htmlentities( $row -> option_value );
						if( !in_array( $row -> option_name, $this -> wp_default_options ) )
							$popular_plugin = "<i>" . __( "Plugin:", "wpom" ) . " " . $this -> _get_popular_plugin( $row -> option_name ) . "</i>";
						else
							$popular_plugin = "<i>" . __( "WordPress internal", "wpom" ) . "</i>";
						print "<tr id=\"wpom_row_{$row->option_id}\" valign=\"top\" class=\"iedit\"><td>{$row->option_id}</td><td><b>" . str_ireplace( $term, "<b style=\"color:red\">$term</b>", $row -> option_name ) . "</b><br/>$popular_plugin</td><td><div style=\"padding-right:10px;overflow:hidden;float:left;\" id=\"wpom_value_{$row->option_id}\">" . str_ireplace( $term, "<b>$term</b>", $row -> option_value ) . "</div></td><td>{$row->autoload}</td><td><a href=\"javascript:;\" onclick=\"if(confirm('" . __( "Really delete this option?! You know what you are doing?!", "wpom" ) . "'))jQuery.ajax({type:'POST',url:'" . $_SERVER[ 'REQUEST_URI' ] . "',data:'wpom_admin_action=delete&id={$row->option_id}',success: function(msg){jQuery('#wpom_row_{$row->option_id}').fadeOut('slow')}});\">" . __( "delete", "wpom" ) . "</a> <a href=\"javascript:;\" onclick=\"jQuery.get('" . $_SERVER[ 'REQUEST_URI' ] . "&wpom_admin_action=debug&id={$row->option_id}',function(txt){txtsplit=txt.split('<!-- WPOM AJAX CONTENT -->'); jQuery('#wpom_value_{$row->option_id}').html(txtsplit[1]);});\">" . __( "debug", "wpom" ) . "</a></td></tr>\n";
					}
				}
				print "</tbody>\n";
				print "</table></p>\n";
			}
			else	print "<p>" . __( "Sorry, nothing found.", "wpom" ) . " :-(</p>";
		}
		print "</div>\n";
		print "</div>\n";
		print "</div>\n";

		// Autosearch
		print "<div id=\"poststuff\">\n";
		print "<div class=\"postbox\">\n";
		print "<form name=\"wpom_searchform\" method=\"POST\" action=\"" . $_SERVER[ "REQUEST_URI" ] . "\" enctype=\"multipart/form-data\">\n";
		print "<input type=\"hidden\" name=\"wpom_admin_action\" value=\"autosearch\"/>\n";
		print "<h3>" . __( "Autosearch deprecated options", "wpom" ) . "</h3>\n";
		print "<div class=\"inside\">\n";
		print "<p>" . __( "What we do here? We will search all plugin files for options used by the plugin and match it against the entrys of the WordPress options database table.", "wpom" ) . "</p>";
		print "<p><br/><b>" . __( "Show options that are unsecure to delete, or be strict?", "wpom" ) . "</b></p>";
		print "<p><select name=\"wpom_show_insecure\">\n";
			print "<option value=\"false\"" . ($_POST[ 'wpom_show_insecure' ] == 'false' ? "selected=\"selected\"" : "") . ">" . __( "No, please be strict!", "wpom" ) . "</option>\n";
			print "<option value=\"true\"" . ($_POST[ 'wpom_show_insecure' ] == 'true' ? "selected=\"selected\"" : "") . ">" . __( "Okay, show me the risky things too!", "wpom" ) . "</option>\n";
		print "</select></p>\n";
		print "<p><br/><b>" . __( "What plugins should be determined?", "wpom" ) . "</b></p>";
		print "<p><select name=\"wpom_determ_plugins\">\n";
			print "<option value=\"active\"" . ($_POST[ 'wpom_determ_plugins' ] == 'active' ? "selected=\"selected\"" : "") . ">" . __( "Only activated plugins", "wpom" ) . "</option>\n";
			print "<option value=\"all\"" . ($_POST[ 'wpom_determ_plugins' ] == 'all' ? "selected=\"selected\"" : "") . ">" . __( "All installed plugins", "wpom" ) . "</option>\n";
		print "</select></p>\n";
		print "<p class=\"submit\"><input type=\"submit\" name=\"wpom_submitsearch\" value=\"" . __( "Match all plugins against options", "wpom" ) . "\"/></p>\n";
		print "</form>\n";
		// Run search
		if( $_POST[ 'wpom_admin_action' ] == 'autosearch' )
		{
			$term = strtolower( mysql_real_escape_string( $_POST[ 'wpom_searchterm' ] ) );
			$rowsfound = $this -> db -> query( "SELECT * FROM {$this->tp}options WHERE 1 ORDER BY blog_id ASC, option_name ASC;" );
			if( $rowsfound )
			{
				$plugin_files = array();
				$plugin_options = array();
				$plugin_options_insecure = array();
				// Load all plugin options
				$read_dirs = array();
				if( $_POST[ 'wpom_determ_plugins' ] == 'active' )
				{
					$active_plugins = get_option( 'active_plugins' );
					foreach( $active_plugins AS $ap )
					{
						$ap_arr = explode( "/", $ap );
						if( count( $ap_arr ) > 1 )
							$read_dirs[] = WPOM_PLUGIN_PATH . $ap_arr[ 0 ];
						else
							$read_dirs[] = WPOM_PLUGIN_PATH . $ap;
					}
				}
				else
				{
					if( $d = opendir( WPOM_PLUGIN_PATH ) )
					{
						while( false !== ($sd = readdir( $d )) )
						{
							if( is_dir( WPOM_PLUGIN_PATH . $sd ) )
								$read_dirs[] = WPOM_PLUGIN_PATH . $sd;
						}
					}
				}
				foreach( $read_dirs AS $dir )
				{
					if( is_dir( $dir ) )
					{
						$d = opendir( $dir );
						while( false !== ($pf = readdir( $d )) )
						{
							if( is_dir( $dir . '/'. $pf ) )
							{
								if( $pf != '.' && $pf != '..' )
									$read_dirs[] = $dir . '/'. $pf;
							}
						}
					}
				}
				// Directorys loaded, now read all files (I did that because I don't want to do it with recursion)
				foreach( $read_dirs AS $dir )
				{
					if( is_dir( $dir ) )
					{
						$d = opendir( $dir );
						while( false !== ($pf = readdir( $d )) )
							$this -> _parse_plugin_file( $plugin_files, $plugin_options, $plugin_options_insecure, $dir, $pf );
					}
					else
					{
						$this -> _parse_plugin_file( $plugin_files, $plugin_options, $plugin_options_insecure, '', $dir );
					}
				}
				$plugin_options = array_unique( $plugin_options );
				$plugin_options_insecure[] = 'rss_';
				$plugin_options_insecure = array_unique( $plugin_options_insecure );
				// Output hits not in plugin_options array
				print "<p><strong>" . __( "Number of total options found:", "wpom" ) . " $rowsfound</strong></p>\n";
				$tbl  = "<p><table class=\"widefat post fixed\">\n";
				$tbl .= "<thead>\n";
				$tbl .= "<tr><th class=\"manage-column\" width=\"80\">" . __( "Option ID", "wpom" ) . "</th><th width=\"200\">" . __( "Option name", "wpom" ) . "</th><th>" . __( "Option value", "wpom" ) . "</th><th width=\"100\">" . __( "Autoloaded?", "wpom" ) . "</th><th width=\"100\">" . __( "Choose action", "wpom" ) . "</th></tr>\n";
				$tbl .= "</thead>\n";
				$tbl .= "<tbody>\n";
				$count_no_match = 0;
				$count_insecure_match = 0;
				foreach( $this -> db -> last_result AS $row )
				{
					if( !in_array( $row -> option_name, $this -> wp_default_options ) && !in_array( $row -> option_name, $plugin_options ) )
					{
						if( !in_array( $row -> option_name, $this -> wp_default_options ) )
							$popular_plugin = "<i>" . __( "Plugin:", "wpom" ) . " " . $this -> _get_popular_plugin( $row -> option_name ) . "</i>";
						else
							$popular_plugin = "<i>" . __( "WordPress internal", "wpom" ) . "</i>";
						$row -> option_value = wordwrap( $row -> option_value, 25, " ", true );
						$row -> option_value = htmlentities( $row -> option_value );
						if( $row -> option_name == str_ireplace( $plugin_options_insecure, '', $row -> option_name ) )
						{
							$row -> option_name = "<b style=\"color:green\">" . __( "Maybe you can delete this:", "wpom" ) . "</b><br/>" . $row -> option_name;
							$tbl .= "<tr id=\"wpom_row_{$row->option_id}\" valign=\"top\" class=\"iedit\"><td>{$row->option_id}</td><td><b>{$row->option_name}</b><br/>$popular_plugin</td><td><div style=\"padding-right:10px;overflow:hidden;float:left;\" id=\"wpom_value_{$row->option_id}\">" . str_ireplace( $term, "<b>$term</b>", $row -> option_value ) . "</div></td><td>{$row->autoload}</td><td><a href=\"javascript:;\" onclick=\"if(confirm('" . __( "Really delete this option?! You know what you are doing?!", "wpom" ) . "'))jQuery.ajax({type:'POST',url:'" . $_SERVER[ 'REQUEST_URI' ] . "',data:'wpom_admin_action=delete&id={$row->option_id}',success: function(msg){jQuery('#wpom_row_{$row->option_id}').fadeOut('slow')}});\">" . __( "delete", "wpom" ) . "</a> <a href=\"javascript:;\" onclick=\"jQuery.get('" . $_SERVER[ 'REQUEST_URI' ] . "&wpom_admin_action=debug&id={$row->option_id}',function(txt){txtsplit=txt.split('<!-- WPOM AJAX CONTENT -->'); jQuery('#wpom_value_{$row->option_id}').html(txtsplit[1]);});\">" . __( "debug", "wpom" ) . "</a></td></tr>\n";
							$count_no_match++;
						}
						else
						if( $_POST[ 'wpom_show_insecure' ] == 'true' )
						{
							$row -> option_name = "<b style=\"color:red\">" . __( "Insecure to delete:", "wpom" ) . "</b><br/>" . $row -> option_name;
							$tbl .= "<tr id=\"wpom_row_{$row->option_id}\" valign=\"top\" class=\"iedit\"><td>{$row->option_id}</td><td><b>{$row->option_name}</b><br/>$popular_plugin</td><td><div style=\"padding-right:10px;overflow:hidden;float:left;\" id=\"wpom_value_{$row->option_id}\">" . str_ireplace( $term, "<b>$term</b>", $row -> option_value ) . "</div></td><td>{$row->autoload}</td><td><a href=\"javascript:;\" onclick=\"if(confirm('" . __( "Really delete this option?! You know what you are doing?!", "wpom" ) . "'))jQuery.ajax({type:'POST',url:'" . $_SERVER[ 'REQUEST_URI' ] . "',data:'wpom_admin_action=delete&id={$row->option_id}',success: function(msg){jQuery('#wpom_row_{$row->option_id}').fadeOut('slow')}});\">" . __( "delete", "wpom" ) . "</a> <a href=\"javascript:;\" onclick=\"jQuery.get('" . $_SERVER[ 'REQUEST_URI' ] . "&wpom_admin_action=debug&id={$row->option_id}',function(txt){txtsplit=txt.split('<!-- WPOM AJAX CONTENT -->'); jQuery('#wpom_value_{$row->option_id}').html(txtsplit[1]);});\">" . __( "debug", "wpom" ) . "</a></td></tr>\n";
							$count_insecure_match++;
						}
					}
				}
				$tbl .= "</tbody>\n";
				$tbl .= "</table></p>\n";
				print "<p>";
				print "<b>" . __( "Options with no match in any plugin file:", "wpom" ) . " $count_no_match</b> (" . __( "This does not mean, that there isn't any plugin that uses the options! Check before you delete!", "wpom" ) . ")<br/>";
				if( $_POST[ 'wpom_show_insecure' ] == 'true' )
					print "<b>" . __( "Options with no direct match in any plugin file, but with some similarities:", "wpom" ) . " $count_insecure_match</b> (" . __( "Check before you delete this options!", "wpom" ) . ")<br/>";
				print "</p>";
				print $tbl;
			}
			else	print "<p>" . __( "Sorry, nothing found in the options table?", "wpom" ) . " :-(</p>";
		}
		print "</div>\n";
		print "</div>\n";
		print "</div>\n";


		// Donate link and support informations
		print "<div id=\"poststuff\">\n";
		print "<div class=\"postbox\">\n";
		print "<h3>" . __( "Donate &amp; support", "wpom" ) . "</h3>\n";
		print "<div class=\"inside\" style=\"line-height:160%;font-size:1em;\">\n";
		print __( "Please", "wpom" ) . " <a href=\"https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=m_schieferdecker%40hotmail%2ecom&item_name=wpom%20wp%20plugin&no_shipping=0&no_note=1&tax=0&currency_code=EUR&bn=PP%2dDonationsBF&charset=UTF%2d8\">" . __( "DONATE", "wpom" ) . "</a> " . __( "if you like this plugin.", "wpom" ) . "<br/>";
		print "<br/>" . __( "If you need support, want to report bugs or suggestions, drop me an ", "wpom" ) . " <a href=\"mailto:m_schieferdecker@hotmail.com\">" . __( "email", "wpom" ) . "</a> " . __( "or visit the", "wpom" ) . " <a href=\"http://wordpress.org/extend/plugins/wp-options-manager/\">" . __( "plugin homepage", "wpom" ) . "</a>.<br/>";
		print "<br/>" . __( "Translations: ", "wpom" ) . " Gianni Diurno (Italiano), Marc Schieferdecker (Deutsch)<br/>";
		print "<br/>" . __( "Final statements: Code is poetry. Motorcycles are cooler than cars.", "wpom" );
		print "</div>";
		print "</div>\n";
		print "</div>\n";


		// Close container
		print "</div>\n";

		// Nice display
		if( version_compare( substr($wp_version, 0, 3), '2.6', '<' ) )
		{
?>
		<script type="text/javascript">
		//<!--
			var a2p_openPanel = <?php print $open; ?>;
			var a2p_PanelCounter = 1;
			jQuery('.postbox h3').prepend('<a class="togbox">+</a> ');
			jQuery('.postbox h3').click( function() { jQuery(jQuery(this).parent().get(0)).toggleClass('closed'); } );
			jQuery('.postbox h3').each(function() {
				if( (a2p_PanelCounter++) != a2p_openPanel )
					jQuery(jQuery(this).parent().get(0)).toggleClass('closed');
			});
		//-->
		</script>
		<style type="text/css">
			h4 {
				margin-bottom:0em;
			}
		</style>
<?php
		}
	}

	function _parse_plugin_file( &$plugin_files, &$plugin_options, &$plugin_options_insecure, $dir, $pf )
	{
		$fSuffix_Arr = explode( ".", $pf );
		$fSuffix = end( $fSuffix_Arr );
		if( strtolower( $fSuffix ) == 'php' )
		{
			if( !empty( $dir ) )
			{
				$plugin_files[] = $dir . '/' . $pf;
				$plugin_source = file_get_contents( $dir . '/' . $pf );
			}
			else
			{
				$plugin_files[] = $pf;
				$plugin_source = file_get_contents( $pf );
			}
			preg_match_all( '/get_option\((.*)(\)|,)/siU', $plugin_source, $matches );
			if( count( $matches[ 0 ] ) )
			{
				foreach( $matches[ 1 ] AS $option )
				{
					$option = str_replace( array( "'", '"', ' ' ), '', $option );
					if( strpos( $option, '$' ) === false && strpos( $option, '.' ) === false )
					{
						$plugin_options[] = $option;
					}
					else
					{
						if( strpos( $option, '.' ) === false )
						{
							$tarr = explode( '->', $option );
							if( count( $tarr ) > 1 )
							{
								$option = trim( end( $tarr ) );
								$vsearch = '/' . preg_quote( $option ) . '.*=.*(\'|")(.*)(\'|");/U';
								preg_match( $vsearch, $plugin_source, $vmatch );
								if( !empty( $vmatch[ 2 ] ) )
									$plugin_options[] = $vmatch[ 2 ];
							}
							else
							{
								$vsearch = '/' . preg_quote( $option ) . '.*=.*(\'|")(.*)(\'|");/U';
								preg_match( $vsearch, $plugin_source, $vmatch );
								if( !empty( $vmatch[ 2 ] ) )
									$plugin_options[] = $vmatch[ 2 ];
							}
						}
						else
						{
							$tarr = explode( '.', $option );
							foreach( $tarr AS $insec_str )
								if( strpos( $insec_str, '(' ) === false && strlen( $insec_str ) > 2 )
									$plugin_options_insecure[] = str_replace( '$', '', $insec_str );
						}
					}
				}
			}
		}
	}

	function _get_popular_plugin( $option )
	{
		if( str_replace( array_keys( $this -> wp_popular_plugins ), '', $option ) != $option )
		{
			foreach( $this -> wp_popular_plugins AS $okey => $plugin )
			{
				if( strpos( $option, $okey ) !== false )
					return $plugin;
			}
		}
		return __( "unknown", "wpom" );
	}
}

// Create class instance
$wpom_Plugin = new wp_options_manager();

// Admin page wrapper
function wrapper_wpom_AdminPage()
{
	global $wpom_Plugin;
	add_options_page( 'WP Options Manager', 'WP Options Manager', 9, basename(__FILE__), array( &$wpom_Plugin, 'wpom_AdminPage' ) );
}

// Add action: Admin page
add_action( 'admin_menu', 'wrapper_wpom_AdminPage' );

?>